#include "core.h"
#include <stdlib.h>

using namespace bpp;

extern "C" void abort_with_error(const string& s)
{
	print << string("Error: ") << s << string("\r\n");
#if defined(__BPP_DEBUG)
	while (true)
	{
		static bool first = true;
		int line = dbg_getline();
		string func = dbg_getfunc();
		if (!line)
			break;
		if (first)
		{
			print << string("    raised");
			first = false;
		}
		else
			print << string(",\r\n    called");
		print << string(" by ") << func << string("() at line #") << line;
	}
	print << string("\r\n");
#endif
	exit(0);
}

int main(int ac, char* av[])
{
	try
	{
		exec_and_seh(__init_all);
		exec_and_seh(Main);
		exec_and_seh(__final_all);
	}
	catch (const string& s)
	{
		abort_with_error(s);
	}
	catch (end)
	{
	}
	return 0;
}