#include "core.h"
#include <windows.h>

using namespace bpp;

extern "C" void abort_with_error(const string& s)
{
	string err = string("Error: ") + s + string("\r\n");
#if defined(__BPP_DEBUG)
	while (true)
	{
		static bool first = true;
		int line = dbg_getline();
		string func = dbg_getfunc();
		if (!line)
			break;
		if (first)
		{
			err = err + string("    raised");
			first = false;
		}
		else
			err = err + string(",\r\n    called");
		err = err + string(" by ") + func + string("() at line #") + line;
	}
	err = err + string("\r\n");
#endif
	MessageBoxA(0, err.cstr(), "Error", 0x10);
	ExitProcess(0);
}

int APIENTRY WinMain(HINSTANCE, HINSTANCE, LPSTR, int)
{
	argc = 0;
	try
	{
		exec_and_seh(__init_all);
		exec_and_seh(Main);
		exec_and_seh(__final_all);
	}
	catch (const string& s)
	{
		abort_with_error(s);
	}
	catch (end)
	{
	}
	return 0;
}