#ifndef _LEXER_H
#define _LEXER_H

#include <string>
#include <iostream>

using namespace std;


class lexer
{
public:
	enum tokkinds { eof, nl, id, num, str, sym, lab };

	string token;
	int tokkind, line, col, col2;
	struct { int chars, tokens, lines; } stats;

	lexer(istream& in);
	void next();

private:
	istream& in;
	char c;

	bool isspace(char c) const;
	bool isalpha(char c) const;
	bool issuffix(char c) const;
	bool isdigit(char c) const;
	bool ishexdigit(char c) const;
	bool issymbol(char c) const;
	void mangle(string& id);
};


#endif