#include "util.h"
#include <windows.h>


bool operator^ (const string& a, const string& b)
{
	return stricmp(a.c_str(), b.c_str()) == 0;
}


string cutfileext(const string& filename)
{
	for (int i = filename.length(); i > 0; i--)
	{
		switch(filename[i])
		{
		case '.':
			return filename.substr(0, i);
		case '\\':
		case '/':
			return filename;
		}
	}
	return filename;
}


string changefileext(const string& filename, const string& ext)
{
	return cutfileext(filename) + '.' + ext;
}


string getfileext(const string& filename)
{
	for (int i = filename.length(); i > 0; i--)
	{
		switch(filename[i])
		{
		case '.':
			return filename.substr(i+1);
		case '\\':
		case '/':
			return "";
		}
	}
	return "";
}


string addfileext(const string& filename, const string& ext)
{
	if (getfileext(filename) == "")
		return filename + '.' + ext;
	else
		return filename;
}


bool fexist(const string& filename)
{
	FILE* F = fopen(filename.c_str(), "rb");
	return (F ? fclose(F), true : false);
}


int fgeti(FILE* in)
{
	int i;
	fread(&i, sizeof(i), 1, in);
	return i;
}


void fputi(int i, FILE* out)
{
	fwrite(&i, sizeof(i), 1, out);
}


string freads(FILE* in)
{
	char buf[1024], *p = buf - 1;
	do
		p++, *p = fgetc(in);
	while (*p);
	return buf;
}


void fwrites(const string& s, FILE* out)
{
	fputs(s.c_str(), out);
	fputc(0, out);
}


string ftos(float n)
{
	char buf[256];
	sprintf(buf, "%f", n);
	return buf;
}


string itos(int n)
{
	char buf[256];
	sprintf(buf, "%d", n);
	return buf;
}

string proper(const string& s)
{
	string result = s;
	strlwr(&result[0]);
	result[0] = toupper(result[0]);
	return result;
}


string getexename()
{
	char progname[1024];
	GetModuleFileName(NULL, progname, sizeof(progname));
	return progname;
}